-- datas.vhd
-- by Toshio Iwata at digitalfilter.com 2009/06/12
-- This module asserts data to D_IN
-- Change DIOB to change bit length

library ieee, STD;
use STD.TEXTIO.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_textio.all;

use work.globals_pkg.all;

entity datas is
   generic (
        DIOB : integer := 16 );
   Port (
          LRCLK : in std_logic;
          CAP : in std_logic;
          SDTO : Out std_logic );
end datas;

architecture beh of datas is

  signal sdata_tmp : signed( DIOB-1 downto 0 );
  signal LRCLK_dly : std_logic;

begin

  LRCLK_dly <= LRCLK after 1 ns;
  
gen_SDTO : process
variable Li : line;
variable first_time : boolean := true;
variable t : real := 0.0;
variable rdata : real := 0.0;
variable idata : integer := 0;
variable bitno : integer := 0;
variable charbuf       : character ;
variable linecount : integer := 0;

begin
  if( first_time ) then
    SDTO <= '0';
    wait until LRCLK = '1';
    first_time := false;
  end if;
  wait for 0 ns;
  SDTO <= sdata_tmp(DIOB - 1 - bitno);
  wait for sv_bclk_period;
  t := t + sv_bclk_value;
  bitno := bitno + 1;
  if( bitno = DIOB ) then
    wait for (sv_fsclk_period/2.0 - (sv_bclk_period * 16.0));
    t := t + (sv_fsclk_value/2.0 - (sv_bclk_value * 16.0));
    bitno := 0;
    if( CAP = '1' and LRCLK_dly = '0' and linecount < 1024 ) then 
      readline(sv_file_in_AD, Li);
      linecount := linecount + 1;
      for i in 0 to 5 loop
        read(Li, charbuf);
        if ( charbuf = '0' ) then
          sdata_tmp(DIOB-1-i) <= '0';
        else 
          sdata_tmp(DIOB-1-i) <= '1';
        end if;
      end loop;
      sdata_tmp(DIOB-1-6 downto 0) <= (others => '0');
    else 
      if(CAP = '0') then 
        linecount := 0;
      end if;
      sdata_tmp <= (others => '0');
    end if;

  end if;
end process;

end beh;
