-- globals_pkg.vhd
-- by Toshio Iwata 2009/06/12

library ieee ;
  use ieee.std_logic_1164.all ;
  use IEEE.std_logic_arith.all;
  use ieee.std_logic_textio.all ;
  use std.textio.all ;

--***************************************************************************
--**
--**  Package
--**
--***************************************************************************

package globals_pkg is

  ----------------------------------------------------------------------------
  --
  --  Chip Related Constants
  --
  ----------------------------------------------------------------------------
  constant sv_mclk_period : time := 20 ns; -- MCLK = 512 * Fs
  constant sv_mclk_value : real := 20.0e-9; -- MCLK = 512 * Fs

  constant sv_fsclk_period : time := 512 * 20 ns; -- FSCLK = 97.7kHz
  constant sv_fsclk_value : real := 512 * 20.0e-9; -- FSCLK = 97.7kHz

  constant sv_bclk_period : time := 8 * 20 ns; 
  constant sv_bclk_value : real := 8 * 20.0e-9; -- BCLK = 6.25MHz

  file sv_file_in : TEXT is in "FixedIn.txt"; -- input file for test mode (directly into RAM)
  file sv_file_in_AD : TEXT is in "FixedIn4AD.txt"; -- input file for normal mode (from A/D)
  
  constant sv_testmode : boolean := TRUE; -- Test mode (data is injected from UP)

end globals_pkg ;

--***************************************************************************
--**
--**  Package Body
--**
--***************************************************************************

package body globals_pkg is

end globals_pkg;

