--------------------------------------------------
-- tb_fft.vhd
-- by Toshio Iwata at digitalfilter.com 2009/06/12

library IEEE;
  use IEEE.std_logic_1164.all;

entity tb_fft is
end tb_fft ;

architecture beh of tb_fft is

component FftRtl 
Port (
  CLK : in std_logic;
  RST_N : in std_logic;
  FIFO_RD_START : in std_logic; 
  FIFO_WR_START : in std_logic; 
  iW_ce0 : out std_logic;
  iW_data : in std_logic_vector( 15 downto 0 )  ; 
  oR_ce0 : out std_logic;
  oR_data : out std_logic_vector( 15 downto 0 )  ; 
  CAP_START : in std_logic; 
  FFT_START : in std_logic; 
  ADATA : In std_logic;
  ALRCLK : Out std_logic; 
  ABCLK : Out std_logic; 
  AMCLK : Out std_logic; 
  UP_IMAG_SEL : In std_logic );
end component;

component clks
   Port (
	  MCLK : out std_logic);
end component;

component datas
   Port (
          LRCLK : in std_logic;
          CAP : in std_logic;
          SDTO : Out std_logic );
end component;

component up_out
   Port (
  up_addr : out std_logic_vector(9 downto 0);
  up_wr_data : out std_logic_vector(15 downto 0);
  up_we_n : out std_logic;
  up_oe_n : out std_logic;
  up_imag_sel : out std_logic;
  iW_ce0 : in std_logic;
  iW_data : out std_logic_vector(15 downto 0);
  FIFO_RD_START : out std_logic;
  FIFO_WR_START : out std_logic;
     CAP : out std_logic;
     FFT : out std_logic;
	  RST : out std_logic);
end component;

signal dummy_low : std_logic;
signal alrclk_signal : std_logic;
signal rst_n_signal : std_logic;
signal mclk_signal : std_logic;
signal sdata_signal : std_logic;
signal up_addr_signal : std_logic_vector(9 downto 0);
signal up_oe_n_signal : std_logic;
signal up_wr_data_signal : std_logic_vector(15 downto 0);
signal up_we_n_signal : std_logic;
signal up_imag_sel_signal : std_logic;
signal cap_signal : std_logic;
signal fft_signal : std_logic;
signal   FIFO_RD_START : std_logic;
signal   FIFO_WR_START : std_logic;
signal iW_ce0 : std_logic;
signal iW_data : std_logic_vector(15 downto 0);
signal oR_ce0 : std_logic;
signal oR_data : std_logic_vector(15 downto 0);

begin

  dummy_low <= '0';

FftRtl_1 : FftRtl port map (
  CLK => mclk_signal,  
  RST_N => rst_n_signal, 
  FIFO_RD_START => FIFO_RD_START, 
  FIFO_WR_START => FIFO_WR_START, 
  iW_ce0 => iW_ce0, 
  iW_data => iW_data, 
  oR_ce0 => oR_ce0, 
  oR_data => oR_data, 
  CAP_START => cap_signal, 
  FFT_START => fft_signal, 
  ADATA => sdata_signal, 
  ALRCLK => alrclk_signal, 
  ABCLK => open, 
  AMCLK => open, 
  up_imag_sel => up_imag_sel_signal );

clks_1 : clks port map (
     MCLK => mclk_signal );

datas_1 : datas port map (
     LRCLK => alrclk_signal,
     CAP => cap_signal, 
     SDTO => sdata_signal );

up_out_1 : up_out port map (
  up_addr => up_addr_signal,
  up_wr_data => up_wr_data_signal,
  up_we_n => up_we_n_signal,
  up_oe_n => up_oe_n_signal,
  up_imag_sel => up_imag_sel_signal,
  FIFO_RD_START => FIFO_RD_START, 
  FIFO_WR_START => FIFO_WR_START, 
  iW_ce0 => iW_ce0, 
  iW_data => iW_data, 
      CAP => cap_signal, 
      FFT => fft_signal, 
  RST => rst_n_signal );

MAIN_P: process

begin -- process MAIN_P

wait ;

end process ;  -- MAIN_P
-----------------------------------------------------------------------
end beh ;
