/* opencvtest.c */
#include <stdio.h>
#include <cv.h>
#include <highgui.h>

#define WIDTH 512

int main (int argc, char *argv[]) {
  IplImage *src, *result;
  char *original = "Original";
  char *canny = "Canny";
  unsigned char pix[WIDTH];
  int x, y;

  if (argc < 2) {
    printf("Usage: opencvtest imagename\n");
    return -1;
  }
  if((src = cvLoadImage(argv[1], CV_LOAD_IMAGE_GRAYSCALE)) == 0) {
    printf("Error: Failed to load %s\n", argv[1]);
    return -1;
  }

  result = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U, 1);
  cvSmooth (src, result, CV_GAUSSIAN, 11, 0, 0, 0);

  y = 10;
  for(x = 0; x < WIDTH; x++) {
    pix[x] = src->imageData[y*WIDTH+ x];
    printf("pix[%d]= %d\n", x, pix[x]);
  }

  cvNamedWindow(original, CV_WINDOW_AUTOSIZE);
  cvNamedWindow(canny, CV_WINDOW_AUTOSIZE);
  cvShowImage(original, src);
  cvShowImage(canny, result);
  cvWaitKey(0);
   
  cvSaveImage("filter.jpg", result, 0);

  cvDestroyWindow(original);
  cvDestroyWindow(canny);
  cvReleaseImage(&src);
  cvReleaseImage(&result);
  
  return 0;
}

