/* opencvtest.c */
#include <stdio.h>
#include <cv.h>
#include <highgui.h>

#define WIDTH 512

int main (int argc, char *argv[]) {
  IplImage *src, *result, *tmp1, *tmp2;
  char *original = "Original";
  char *canny = "Canny";
  unsigned char pix[WIDTH];
  int x, y;

  src = cvLoadImage("fftres.jpg", CV_LOAD_IMAGE_GRAYSCALE);
  result = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U, 1);
  tmp1 = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U, 1);
  tmp2 = cvCreateImage(cvGetSize(src), IPL_DEPTH_8U, 1);

  for(y = 0; y < WIDTH; y++) {
    for(x = 0; x < WIDTH/2; x++) {
      pix[x] = src->imageData[y*WIDTH+ x];
      tmp1->imageData[y*WIDTH + (WIDTH/2-x)] = pix[x];
    }
    for(x = WIDTH/2; x < WIDTH; x++) {
      pix[x] = src->imageData[y*WIDTH+ x];
      tmp1->imageData[y*WIDTH + WIDTH-(x-WIDTH/2)] = pix[x];
    }
  }

  for(y = 0; y < WIDTH/2; y++) {
    for(x = 0; x < WIDTH; x++) {
      pix[x] = tmp1->imageData[y*WIDTH+ x];
      tmp2->imageData[(WIDTH/2-y)*WIDTH + x] = pix[x];
    }
  }
  for(y = WIDTH/2; y < WIDTH; y++) {
    for(x = 0; x < WIDTH; x++) {
      pix[x] = tmp1->imageData[y*WIDTH+ x];
      tmp2->imageData[(WIDTH-(y-WIDTH/2))*WIDTH + x] = pix[x];
    }
  }

  for(y = 0; y < WIDTH; y++) {
    for(x = 0; x < WIDTH; x++) {
      pix[x] = tmp2->imageData[y*WIDTH+ x];
      result->imageData[x*WIDTH + y] = pix[x] << 2;
    }
  }

//      printf("pix[%d]= %d\n", x, pix[x]);

  cvNamedWindow(original, CV_WINDOW_AUTOSIZE);
  cvNamedWindow(canny, CV_WINDOW_AUTOSIZE);
  cvShowImage(original, src);
  cvShowImage(canny, result);
  cvWaitKey(0);
   
  cvSaveImage("xyinverted.jpg", result, 0);

  cvDestroyWindow(original);
  cvDestroyWindow(canny);
  cvReleaseImage(&src);
  cvReleaseImage(&result);
  
  return 0;
}

